. $Header: /n/yam/da/dpwe/projects/recogviz/RCS/recogviz.man,v 1.2 1998/02/22 22:03:52 dpwe Exp $
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.de UR		\" URL i.e. web address (1998feb22 dpwe)
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.TH RECOGVIZ 1 "$Date: 1998/02/22 22:03:52 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
recogviz \- interactive front-end for visualizing and comparing speech recognizers
.SH SYNOPSIS
\fBrecogviz
defaults=\fIdefaultfile\fB
recog1=\fIrecog1deffile\fB
[recog2=\fIrecog2deffile\fB]
[utid=\fIstartid\fB]
.SH DESCRIPTION
.PN recogviz
is an application employing many of the Tcl/Tk visualization modules that 
have been developed at ICSI to provide a dynamic, graphical display of 
the recognition process in progress, possibly running two recognizers in 
parallel so that their performance may be compared in detail side-by-side.
The display shows 4 panels for each recognizer: the (wideband) spectrogram of 
the original sound, the feature vectors calculated by the front-end (in a 
similar 2-D grayscale display), the posterior phone probabilities from the 
classifier (shown as superimposed traces), and the phone and word label 
alignments reported by the decoder.  By default, the standard ICSI programs 
are used - 
.MS rasta 1 
for feature calculation, 
.MS qnsfwd 1 
for neural-net classification, and 
.MS noway 1 
for HMM decoding.
.SH PARAMETER SPECIFICATION
The particular recognizer configuration is specified by a series of 
declarations in the definition files specified on the command line.  
These files are (for now) executed as straight Tcl source, and should 
therefore set up parameters using Tcl syntax ("set varname value" and 
"#" at the start of comment lines).
The \f4defaults\f1 file sets up common values, whereas \f4recog1\f1 and 
\f4recog2\f1 define the parameters specific to each recognizer.  
The defaults file should define:
.TP 12
\f4listfile\f1
an ascii list of the utterance IDs in the 
related pfiles, used to map between the two.
.P
Additionally, it can redefine the FWDPASStemplate and DECODEtemplate
from the standard ones within recogui.itcl.
.P
The other parameters to be defined in the defaults or recog files are:
.TP 12
\f4title\f1
a name for the particular recognizer
.TP 12
\f4FEACALC\f1
The command line to convert online audio to 
to online features.  Should be "" if a pfile is 
to be used as the source of features.
.TP 12
\f4FWDPASS\f1
The command line to convert online features into
online posterior probabilities.  However, if
this is left undefined, it will be constructed 
by substituting the other variables into the 
standard FWDPASStemplate.
.TP 12
\f4DECODE\f1
The command line to convert online probabilities 
into utterances.  This should be a version of 
noway that supports -ctm and -phone_decode in 
the same way as noway-2.4, but it should not 
include the -ctm, -phone_decode and -frame_shift
options as they will be added later.  Leaving 
DECODE undefined will cause the program to 
generate it by substituting into the standard
DECODEtemplate.
.TP 12
\f4wavfilecmd\f1
the command that returns the full path to the 
waveform file from the utterance ID (i.e. from 
the list file).  Any occurrence of "%u" in this 
this string will be replaced by the utterance 
ID before executing the command.
.TP 12
\f4samplerate\f1
the sampling rate of the wav files.
.TP 12
\f4wavskewtime\f1
delay between start of features and start of 
wav file, for alignment.  This arises because 
of the 10 frames of silence typically added to 
each file in number95 (wavskewtime = 0.100)
.TP 12
\f4frametime\f1
the time between successive frames (in seconds).
.TP 12
\f4ftr_file\f1
the name of the pfile containing the utterance 
features.
.P
To use the standard FWDPASStemplate, the following fields 
must be defined (those marked with (*) are required even if 
the standard template is not being used):
.TP 12
\f4ftr_width\f1*
the total width of the feature vector
.TP 12
\f4ftr_start\f1
the first feature actually used (1 to skip 0th ftr)
.TP 12
\f4ftr_window_len\f1*
the number of feature vectors seen by the 
neural net at each instant
.TP 12
\f4norm_file\f1*
the file defining feature normalization constants
.TP 12
\f4weights\f1
the weight file definition
.TP 12
\f4mlp3_hidden_size\f1
the number of hidden units in the weight file
.TP 12
\f4mlp3_output_size\f1
the number of output units (phone labels)
.TP 12
\f4mlp3_output_type\f1
type of output unit (softmax)
.P
The following variables must be defined for the standard DECODEtemplate:
.TP 12
\f4phone_models\f1
noway phone models
.TP 12
\f4dictionary\f1
noway dictionary
.TP 12
\f4bigram\f1
noway bigram grammar
.TP 12
\f4acoustic_scale\f1
noway's acoustic model scaling factor (0.125)
.TP 12
\f4priors\f1
prior probabilities definition
.P
Specifying "utid=xxx" on the command line (where xxx is one of the ids 
from the utterance ID list defined in the parameter files, or just an index 
number if no utterance ID list is used) causes the system to immediately 
start recognition of that utterance after starting up.

.SH USER-INTERFACE
The user-interface that appears when the program is run offers the 
following controls:
.PP
* A scrollable list of all the utterance IDs specified in the list file.  
Clicking on one of these IDs causes it to be passed to the recognizer(s) 
for processing and display.
.PP
* A "Play" button, which will play the currently-selected soundfile over 
the computer's speaker
.PP
* A "Print" button, which brings up a dialog box to control the generation 
of a postscript equivalent of the main recognizers display, suitable for 
incorporation into papers
.PP
* A "Quit' button to exit the application.
.PP
Note: it is possible to run the main recogui.itcl file under itclsh 
(the non-graphical version) rather than itkwish (the windowing shell).  
In this case, no graphics are generated (of course!), but the 
recognizers are still executed, and their final word hypotheses are 
printed to the terminal.  This allows a quick check of the configuration 
files and the agreement between recognizers on a particular example 
(e.g. specified with the "utid=" option).
.SH FILES
$(prefix)/share/lib/drspeech_tcl is the default install location of
the subsidiary Tcl scripts, including \f4pfile_cat\f1, an executable 
script to simulate the output of the online 
feature calculation by reading back part of a pfile - which should 
probably be replaced by an enhanced version of 
.MS pfile_print 1 .
.SH DEPENDENCIES
Clearly, the program relies on the rasta, qnsfwd and noway binaries.
.P
It also requires the C++-aware version of the [incr Tcl] 2.x shell, 
as generated by my tclsh-readline-0.3 package.
.P
It also requires a large number of Tcl extensions: Sound, StftSound, 
Pfif, Farray, Dpweutils and Dpwe_Utilfns.  These are available 
separately!
.P
Both recogui.itcl and pfile_cat.tcl are hard-coded to search for their 
needed packages under /u/dpwe at present.  Until I finish building dist'able 
versions of packages like dpweutils_tcl, this is where they will be.
.SH ENVIRONMENT
.PN recogviz
relies on the standard \f4$DRSPEECH_PATH\f1 to find the various 
programs it uses, and \f4$DRSPEECH_LIBRARY_PATH\f1 to find local 
Tcl and Perl extensions (as required, for instance, by 
.PN numbers95_findfile ,
which is often defined to be called by the program).  
If these environment variables are not 
set, but the older convention \f4$SPEECH_DIR\f1 is defined, 
default paths will be build based on it.
.SH SEE ALSO
The recogviz homepage, 
.UR http://www.icsi.berkeley.edu/~dpwe/projects/recogviz .
.SH BUGS
The definition files are just executed directly by the Tcl interpreter. 
This permits the user to do any kind of mischeif by including arbitrary 
Tcl statements to redefine procedures or whatever.  They might even 
redefine a critical internal variable unintentionally.  On the other hand, 
this is an efficient and flexible solution.
.P
Using Tcl syntax for the definition files is non-standard and uncomfortable 
for many users.  It should support the shell/make style NAME = value 
constructs used in other configuration files (perhaps via regsub 
preprocessing, or by Tcl's "unknown" construct).  It would be nice if it 
could read the exact same configuration files used by dr_recog or dr_embed 
(since it is doing many of the same things).  However, they use Y0 instead 
of NOWAY as the decoder (at leat at present), so the parameters are 
not interchangeable.
.SH AUTHOR
Dan Ellis <dpwe@ICSI.Berkeley.EDU>
